<?php

declare(strict_types=1);

namespace App\Repository;

final class SolicitudRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $SolicitudId): object
    {
        $query = 'SELECT * FROM `Solicitud` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $SolicitudId);
        $statement->execute();
        $Solicitud = $statement->fetchObject();
        if (! $Solicitud) {
            throw new \Exception('Solicitud not found.', 404);
        }

        return $Solicitud;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `Solicitud` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $Solicitud): object
    {
        $query = 'INSERT INTO `Solicitud` (`NombreCompleto`, `CorreoElectronico`, `NumeroCelular`, `Comentarios`, `Condiciones`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:NombreCompleto, :CorreoElectronico, :NumeroCelular, :Comentarios, :Condiciones, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $Solicitud->id);
//         $statement->bindParam('fecha', $Solicitud->fecha);
        $statement->bindParam('NombreCompleto', $Solicitud->NombreCompleto);
        $statement->bindParam('CorreoElectronico', $Solicitud->CorreoElectronico);
        $statement->bindParam('NumeroCelular', $Solicitud->NumeroCelular);
        $statement->bindParam('Comentarios', $Solicitud->Comentarios);
        $statement->bindParam('Condiciones', $Solicitud->Condiciones);
        $statement->bindParam('field1', $Solicitud->field1);
        $statement->bindParam('field2', $Solicitud->field2);
        $statement->bindParam('field3', $Solicitud->field3);
        $statement->bindParam('field4', $Solicitud->field4);
        $statement->bindParam('field5', $Solicitud->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $Solicitud, object $data): object
    {
        if (isset($data->fecha)) {
            $Solicitud->fecha = $data->fecha;
        }
        if (isset($data->NombreCompleto)) {
            $Solicitud->NombreCompleto = $data->NombreCompleto;
        }
        if (isset($data->CorreoElectronico)) {
            $Solicitud->CorreoElectronico = $data->CorreoElectronico;
        }
        if (isset($data->NumeroCelular)) {
            $Solicitud->NumeroCelular = $data->NumeroCelular;
        }
        if (isset($data->Comentarios)) {
            $Solicitud->Comentarios = $data->Comentarios;
        }
        if (isset($data->Condiciones)) {
            $Solicitud->Condiciones = $data->Condiciones;
        }
        if (isset($data->field1)) {
            $Solicitud->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $Solicitud->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $Solicitud->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $Solicitud->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $Solicitud->field5 = $data->field5;
        }

        $query = 'UPDATE `Solicitud` SET `fecha` = :fecha, `NombreCompleto` = :NombreCompleto, `CorreoElectronico` = :CorreoElectronico, `NumeroCelular` = :NumeroCelular, `Comentarios` = :Comentarios, `Condiciones` = :Condiciones, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $Solicitud->id);
        $statement->bindParam('fecha', $Solicitud->fecha);
        $statement->bindParam('NombreCompleto', $Solicitud->NombreCompleto);
        $statement->bindParam('CorreoElectronico', $Solicitud->CorreoElectronico);
        $statement->bindParam('NumeroCelular', $Solicitud->NumeroCelular);
        $statement->bindParam('Comentarios', $Solicitud->Comentarios);
        $statement->bindParam('Condiciones', $Solicitud->Condiciones);
        $statement->bindParam('field1', $Solicitud->field1);
        $statement->bindParam('field2', $Solicitud->field2);
        $statement->bindParam('field3', $Solicitud->field3);
        $statement->bindParam('field4', $Solicitud->field4);
        $statement->bindParam('field5', $Solicitud->field5);

        $statement->execute();

        return $this->checkAndGet((int) $Solicitud->id);
    }

    public function delete(int $SolicitudId): void
    {
        $query = 'DELETE FROM `Solicitud` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $SolicitudId);
        $statement->execute();
    }
}
